Search.setIndex({"docnames": ["conventions", "coord_format", "csc_format", "index", "install", "lsmr", "matrix_util", "random", "random_matrix", "rutherford_boeing", "scaling", "ssids", "ssmfe", "ssmfe_core", "ssmfe_expert"], "filenames": ["conventions.rst", "coord_format.rst", "csc_format.rst", "index.rst", "install.rst", "lsmr.rst", "matrix_util.rst", "random.rst", "random_matrix.rst", "rutherford_boeing.rst", "scaling.rst", "ssids.rst", "ssmfe.rst", "ssmfe_core.rst", "ssmfe_expert.rst"], "titles": ["Data types and conventions", "Coordinate (Coord) Format", "Compressed Sparse Column (CSC) Format", "The Sparse Parallel Robust Algorithms Library", "Installation", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_lsmr</span></code> - Sparse Least Squares LSMR Solver", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_matrix_util</span></code> - Matrix utilities", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_random</span></code> - Pseudo-random number generator", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_random_matrix</span></code> - Pseudo-random Matrix Generator", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_rutherford_boeing</span></code> - RB File Format Utilities", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_scaling</span></code> - Sparse matrix scalings", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_ssids</span></code> - Sparse Symmetric Indefinite Direct Solver", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_ssmfe</span></code> - Sparse Symmetric Matrix-Free Eigensolver", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_ssmfe_core</span></code> - Sparse Symmetric Matrix-Free Eigensolver (Core Algorithm)", "<code class=\"xref f f-mod docutils literal notranslate\"><span class=\"pre\">spral_ssmfe_expert</span></code> - Sparse Symmetric Matrix-Free Eigensolver (Expert interface)"], "terms": {"In": [0, 4, 5, 8, 10, 11, 12, 13, 14], "thi": [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "document": [0, 4, 5, 6, 14], "we": [0, 4, 5, 7, 9, 10, 11, 13, 14], "us": [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13], "integ": [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "long": [0, 1, 2, 7, 8, 9, 11], "denot": 0, "64": [0, 2, 8, 12], "bit": [0, 2, 4, 8, 11], "where": [0, 5, 9, 10, 11, 12, 13, 14], "selected_int_kind": [0, 7, 9, 11], "18": [0, 5, 7, 9, 11], "real": [0, 1, 2, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "mean": [0, 10, 13], "either": [0, 2, 5, 7, 8, 9, 11, 12, 13, 14], "32": [0, 2, 11], "float": [0, 11], "point": [0, 11, 12, 13, 14], "most": [0, 2, 11, 12, 14], "packag": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "onli": [0, 1, 2, 5, 6, 8, 9, 10, 11, 12, 13, 14], "implement": [0, 12, 13, 14], "latter": [0, 4, 9, 12, 13, 14], "i": [0, 1, 2, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14], "e": [0, 4, 5, 9, 10, 11, 12, 13, 14], "doubl": [0, 11, 12, 13, 14], "precis": [0, 11, 12, 13, 14], "ar": [0, 1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "indic": [0, 1, 2, 5, 8, 9, 10, 11, 13], "squar": [0, 3, 6, 12, 13, 14], "bracket": 0, "list": [0, 4], "strongli": [0, 5, 12, 14], "recommend": [0, 4, 9, 11, 12, 13, 14], "keyword": 0, "when": [0, 9, 12, 13, 14], "rather": [0, 13], "than": [0, 2, 4, 5, 8, 11, 12, 13, 14], "reli": [0, 13, 14], "posit": [0, 2, 6, 7, 8, 9, 10, 11, 12, 13, 14], "which": [0, 4, 5, 8, 10, 11, 12, 13, 14], "you": [0, 1, 2, 4], "For": [0, 1, 2, 4, 5, 9, 10, 11, 12, 13, 14], "exampl": [0, 4], "call": [0, 5, 7, 8, 9, 10, 11, 12, 13, 14], "rb_peek": [0, 9], "matrix": [0, 1, 2, 3, 5, 11], "rb": [0, 3, 11], "inform": [0, 5, 9, 10, 11, 12, 13, 14], "matrix_typ": [0, 8, 9], "mat_typ": 0, "titl": [0, 9], "mat_titl": 0, "standard": [1, 2, 4, 7, 10, 12], "data": [1, 2, 3, 4, 5, 6, 9, 12, 13, 14], "consist": [1, 2, 11, 12, 14], "follow": [1, 2, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14], "m": [1, 2, 5, 6, 7, 8, 9, 10, 12, 13, 14], "number": [1, 2, 3, 4, 5, 8, 9, 10, 11, 12, 13, 14], "row": [1, 2, 5, 8, 9, 10, 11, 13, 14], "unsymmetr": [1, 2, 6, 8, 9, 10], "n": [1, 2, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "column": [1, 3, 5, 8, 9, 10, 11, 12, 13, 14], "ne": [1, 6, 11, 13], "entri": [1, 2, 6, 8, 9, 10, 11, 13], "mai": [1, 2, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14], "have": [1, 2, 5, 8, 9, 10, 11, 12, 13, 14], "type": [1, 2, 3, 8], "size": [1, 2, 8, 9, 11, 12, 13, 14], "col": [1, 10, 11], "val": [1, 2, 5, 8, 9, 10, 11], "numer": [1, 2, 4, 5, 10, 11, 12, 13, 14], "valu": [1, 2, 4, 5, 6, 7, 8, 10, 11, 12, 13, 14], "The": [1, 2, 4, 5, 7, 8, 9, 10, 11, 12], "arrai": [1, 2, 5, 9, 10, 11, 12, 13, 14], "should": [1, 2, 4, 5, 7, 8, 9, 11, 12, 13, 14], "set": [1, 4, 5, 9, 10, 11, 12, 13, 14], "k": [1, 2, 5, 9, 10, 12, 13, 14], "th": [1, 2, 13, 14], "zero": [1, 2, 5, 8, 9, 10, 11, 12, 13, 14], "includ": [1, 2, 4], "those": [1, 2, 11, 12, 13, 14], "diagon": [1, 2, 8, 9, 10, 11, 12, 13, 14], "need": [1, 2, 10, 11, 13, 14], "specifi": [1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "symmetr": [1, 2, 3, 4, 6, 8, 9, 10], "matric": [1, 2, 6, 8, 9, 10, 12, 13, 14], "lower": [1, 2, 8, 9, 10, 11, 12, 14], "upper": [1, 5, 9, 13, 14], "triangular": [1, 2, 9, 11, 12, 14], "A": [1, 2, 4, 5, 8, 9, 10, 11, 12, 13, 14], "suppli": [1, 2, 5, 8, 9, 11, 12, 13, 14], "all": [1, 2, 4, 5, 6, 8, 9, 10, 11, 12, 13, 14], "duplic": [1, 2, 11], "sum": [1, 5, 8, 10, 11, 13, 14], "out": [1, 2, 4, 5, 8, 9, 10, 11, 12, 13, 14], "rang": [1, 2, 7, 8, 10, 11, 12, 13, 14], "ignor": [1, 9, 11], "some": [1, 5, 7, 10, 11], "spral": [1, 2], "routin": [1, 2, 5, 6, 9, 11, 12, 13, 14], "offer": [1, 2, 4], "input": [1, 5, 11], "csc": [1, 3, 5, 8, 9, 10, 11], "from": [1, 2, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14], "spral_matrix_util": [1, 2, 3, 8, 9, 10], "convert": [1, 2, 9], "To": [1, 2, 4, 5, 10, 12, 13, 14], "illustr": [1, 2, 5], "left": [1, 2, 5, 7, 11, 12, 13, 14], "begin": [1, 2, 5, 11, 14], "ccccc": [1, 2, 11], "1": [1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "2": [1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "3": [1, 2, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "4": [1, 2, 4, 5, 6, 8, 9, 10, 11, 12, 13, 14], "5": [1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "6": [1, 2, 5, 6, 8, 9, 10, 11, 12, 13, 14], "7": [1, 2, 5, 8, 10, 11, 12, 13, 14], "8": [1, 2, 5, 8, 9, 10, 11, 12, 13], "9": [1, 2, 5, 8, 9, 10, 11, 12, 14], "end": [1, 2, 5, 7, 8, 9, 10, 11, 12, 13, 14], "right": [1, 2, 4, 5, 7, 9, 11, 12, 13, 14], "describ": [1, 2, 9, 11, 13], "ptr": [2, 5, 8, 9, 10, 11], "pointer": [2, 8, 9, 10, 11], "non": [2, 8, 9, 10, 11, 12, 13, 14], "order": [2, 4, 8, 10, 11, 12, 13, 14], "increas": [2, 5, 10, 13], "index": [2, 3, 12, 13, 14], "store": [2, 7, 9, 11, 12, 13, 14], "hold": [2, 10, 11, 13], "first": [2, 5, 8, 9, 10, 11, 12, 13, 14], "one": [2, 5, 8, 9, 11, 12, 13, 14], "more": [2, 4, 5, 11, 12, 13, 14], "total": [2, 5, 11], "fortran": [2, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14], "default": [2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "There": [2, 5, 11], "must": [2, 4, 5, 11, 12, 13, 14], "note": [2, 5, 8, 9, 10, 11, 12, 13, 14], "check": [2, 4, 5, 12, 14], "user": [2, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "behaviour": [2, 6, 10, 11], "misformat": 2, "undefin": [2, 8], "10": [2, 4, 5, 9, 10, 11, 12, 13], "introduct": 3, "convent": [3, 11], "instal": 3, "format": [3, 5, 6, 8, 10, 11], "compress": [3, 8], "coordin": [3, 11], "coord": 3, "spral_lsmr": 3, "least": [3, 4, 8, 10, 11, 12, 13, 14], "lsmr": 3, "solver": [3, 4, 12, 13, 14], "util": [3, 8], "spral_random": [3, 8, 9, 13, 14], "pseudo": 3, "random": [3, 12, 13, 14], "gener": [3, 4, 5, 10, 11, 12], "spral_random_matrix": 3, "spral_rutherford_bo": 3, "file": [3, 4], "spral_scal": [3, 11], "scale": [3, 11, 13, 14], "spral_ssid": [3, 12, 14], "indefinit": [3, 4, 6, 8, 9, 10, 12, 14], "direct": [3, 4, 12, 13, 14], "spral_ssmf": [3, 13, 14], "free": [3, 5, 11], "eigensolv": 3, "spral_ssmfe_expert": [3, 12, 13], "expert": 3, "interfac": [3, 12, 13], "spral_ssmfe_cor": [3, 12, 14], "core": [3, 12, 14], "modul": [3, 9, 12, 13, 14], "search": [3, 12, 13, 14], "page": [3, 11], "now": [4, 10], "system": [4, 5, 11, 12, 13, 14], "under": 4, "linux": 4, "maco": 4, "window": 4, "setup": [4, 13, 14], "builddir": 4, "dexampl": 4, "true": [4, 5, 7, 8, 10, 11, 13, 14], "dtest": 4, "dlibbla": 4, "openbla": 4, "dliblapack": 4, "c": [4, 5, 7, 9, 11, 13], "test": [4, 5, 9, 12, 13, 14], "particular": [4, 10, 11], "interest": [4, 13], "prefix": 4, "path": [4, 10], "usr": 4, "local": [4, 11], "whether": [4, 9, 12, 14], "against": [4, 12, 13, 14], "link": 4, "lapack": [4, 12, 13], "dlibhwloc": 4, "hwloc": [4, 11], "dlibmeti": 4, "dlibmetis_vers": 4, "version": [4, 11], "dmetis64": 4, "64bit": 4, "how": [4, 5, 10, 11], "abov": [4, 5, 10, 11, 12, 13, 14], "pleas": [4, 10, 11, 12, 14], "see": [4, 5, 8, 9, 10, 11, 12, 13, 14], "meson_opt": 4, "txt": 4, "get": 4, "latest": 4, "develop": 4, "github": 4, "run": [4, 9, 11, 12, 14], "dev": 4, "script": 4, "git": 4, "clone": 4, "depth": [4, 11], "http": 4, "com": 4, "ralna": 4, "cd": 4, "autogen": 4, "sh": 4, "mkdir": 4, "cp": 4, "nvcc_arch_sm": 4, "If": [4, 5, 8, 9, 10, 11, 12, 13, 14], "gpu": [4, 11], "l": [4, 5, 11, 12, 13, 14], "lmeti": 4, "make": [4, 12, 13, 14], "sudo": 4, "your": 4, "code": [4, 5, 7, 8, 10, 11, 12, 13, 14], "gfortran": 4, "o": [4, 9], "myprog": 4, "myobj": 4, "lspral": 4, "lbla": 4, "instruct": 4, "perform": [4, 5, 10, 12, 13, 14], "an": [4, 5, 7, 8, 9, 10, 11, 12, 13, 14], "chang": [4, 5, 10, 11, 13, 14], "reflect": [4, 10], "13": [4, 11, 12, 13, 14], "driver": 4, "program": [4, 5, 7, 8, 9, 10, 12, 13, 14], "requir": [4, 5, 8, 9, 10, 11, 12, 13, 14], "mani": [4, 5, 11], "case": [4, 5, 8, 11, 12, 13, 14], "suffici": [4, 5, 9, 12, 13, 14], "just": 4, "static": 4, "found": [4, 5, 9, 10, 11, 13, 14], "lib": 4, "subdirectori": 4, "our": 4, "graph": 4, "partit": 4, "find": [4, 10, 11, 12, 13, 14], "good": [4, 5, 12, 13, 14], "can": [4, 5, 7, 8, 10, 11, 12, 13, 14], "obtain": [4, 5, 10, 11], "copi": [4, 13, 14], "www": 4, "umn": 4, "edu": 4, "both": [4, 8, 9, 10, 11, 12, 13, 14], "avail": [4, 5, 7, 9, 12, 13, 14], "open": [4, 6, 9], "sourc": [4, 9], "apach": 4, "libmeti": 4, "directori": 4, "0": [4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14], "high": [4, 5, 12, 13, 14], "effici": [4, 10, 11], "dens": 4, "linear": [4, 5, 7, 10, 12, 13, 14], "algebra": [4, 5, 12, 13, 14], "oper": [4, 5, 9, 10, 11, 12, 13, 14], "best": 4, "comput": [4, 5, 11, 12, 13, 14], "manufactur": 4, "normal": [4, 5, 11, 13], "intel": 4, "mkl": 4, "optim": [4, 10, 12, 13, 14], "altern": [4, 9, 12], "refer": [4, 9, 10], "netlib": 4, "magnitud": [4, 13], "slower": [4, 11], "modern": [4, 12, 13, 14], "avoid": [4, 5], "compat": [4, 5, 11], "result": [4, 10, 11, 12], "desir": [4, 11, 12, 13, 14], "detect": [4, 11, 13], "wrong": 4, "gnu": 4, "suit": 4, "opt": 4, "intel64": 4, "lmkl_gf_lp64": 4, "lmkl_gnu_thread": 4, "lmkl_core": 4, "pick": 4, "cannot": 4, "appropri": 4, "wish": [4, 6, 11, 13, 14], "differ": [4, 5, 9, 10, 11, 12, 13, 14], "do": [4, 5, 9, 10, 12, 13, 14], "so": [4, 5, 7, 9, 10, 11, 12, 13, 14], "variabl": [4, 7, 10, 11], "cc": 4, "fc": 4, "90": 4, "95": 4, "2003": 4, "2008": [4, 12, 13, 14], "2018": 4, "nvcc": 4, "cuda": [4, 11], "addition": [4, 13], "flag": [4, 5, 8, 10, 11, 12, 13, 14], "cflag": 4, "pass": [4, 7, 10, 11], "fcflag": 4, "nvccflag": 4, "ifort": 4, "g": [4, 5, 9, 12, 13, 14], "o3": 4, "ip": 4, "could": [4, 5], "autoconf": 4, "henc": [4, 12, 13, 14], "command": [4, 11], "help": [4, 5], "write": [4, 5, 7, 8, 10, 11], "paper": [4, 10, 11], "softwar": [4, 11], "usual": [4, 9], "method": 4, "section": [4, 9, 10, 11, 12, 13, 14], "j": [4, 5, 9, 10, 11, 12, 13, 14], "hogg": [4, 10, 11], "ovtchinnikov": [4, 11, 12, 13, 14], "scott": [4, 10, 11], "2016": [4, 5, 6, 7, 8, 9, 11], "spars": [4, 8, 9], "architectur": [4, 7, 11, 12, 13, 14], "acm": [4, 11], "transact": [4, 11], "mathemat": [4, 11], "tom": 4, "42": [4, 11], "25": [4, 11, 12], "dx": [4, 11, 12], "doi": [4, 5, 11], "org": 4, "1145": [4, 11], "275654": 4, "citat": 4, "websit": 4, "2024": 4, "05": [4, 5, 11], "08": [4, 7, 8, 9], "rl": 4, "ac": 4, "uk": 4, "feeback": 4, "sent": 4, "hsl": [4, 9, 10], "stfc": [4, 10], "issu": [4, 11], "copyright": 4, "2014": [4, 7, 8, 10, 11, 13, 14], "2023": 4, "scienc": 4, "technologi": 4, "facil": 4, "council": 4, "reserv": 4, "redistribut": [4, 9], "binari": 4, "form": [4, 5, 7, 10, 13, 14], "without": [4, 5, 9, 10, 11, 12, 13, 14], "modif": 4, "permit": [4, 9], "provid": [4, 5, 8, 9, 10, 11, 12, 13, 14], "condit": [4, 5, 10, 12, 13, 14], "met": 4, "retain": [4, 13, 14], "notic": 4, "disclaim": 4, "reproduc": [4, 7], "materi": 4, "distribut": 4, "neither": 4, "name": [4, 9, 12], "nor": 4, "its": [4, 10, 11, 12, 13, 14], "contributor": 4, "endors": 4, "promot": 4, "product": [4, 5, 10, 13, 14], "deriv": [4, 10], "specif": [4, 10, 14], "prior": 4, "written": 4, "permiss": [4, 11], "BY": 4, "THE": 4, "holder": 4, "AND": 4, "AS": 4, "ani": [4, 5, 7, 8, 9, 10, 11, 12, 14], "express": [4, 7], "OR": 4, "impli": 4, "warranti": 4, "BUT": 4, "NOT": 4, "limit": [4, 5, 13], "TO": 4, "OF": 4, "merchant": 4, "fit": 4, "FOR": 4, "purpos": 4, "IN": 4, "NO": 4, "event": [4, 5, 10, 11, 12, 13, 14], "shall": 4, "BE": 4, "liabl": 4, "indirect": 4, "incident": 4, "special": 4, "exemplari": 4, "consequenti": 4, "damag": [4, 13], "procur": 4, "substitut": 4, "servic": 4, "loss": [4, 13], "profit": 4, "busi": 4, "interrupt": 4, "howev": [4, 5, 8, 9, 10, 11, 12, 13, 14], "caus": [4, 11, 13], "ON": 4, "theori": [4, 10], "liabil": 4, "contract": 4, "strict": 4, "tort": 4, "neglig": [4, 13], "otherwis": [4, 5, 7, 8, 9, 10, 11, 13, 14], "aris": 4, "wai": [4, 5, 10], "even": 4, "IF": 4, "advis": 4, "possibl": [4, 5, 8, 11, 12, 13, 14], "SUCH": 4, "iter": [5, 10, 12, 13, 14], "solv": [5, 10, 11, 12, 13, 14], "equat": [5, 11, 12, 13, 14], "problem": [5, 10, 11, 12], "ll": 5, "mbox": [5, 10], "nonsymmetr": 5, "minim": [5, 10, 11, 12, 13, 14], "x": [5, 8, 11, 12, 13, 14], "_2": [5, 12, 14], "subject": 5, "ax": [5, 11, 12, 13, 14], "b": [5, 7, 10, 11, 12, 13, 14], "regular": 5, "lambda": [5, 12, 13, 14], "time": [5, 8, 10, 11, 12, 13, 14], "rectangular": [5, 6, 8, 9, 10, 12], "rank": [5, 10, 11], "scalar": 5, "damp": 5, "paramet": [5, 7, 8, 9, 10, 11, 12, 13, 14], "solut": [5, 10, 11, 12, 13, 14], "sens": 5, "uniqu": 5, "soluton": 5, "alwai": [5, 8, 10], "exist": [5, 9, 10, 11, 12, 14], "bound": [5, 10, 13, 14], "precondit": 5, "try": 5, "reduc": [5, 11, 13], "suitabl": 5, "choic": 5, "precondition": [5, 12, 13, 14], "depend": [5, 10, 11, 12, 13, 14], "": [5, 9, 10, 11, 13, 14], "knowledg": 5, "chosen": [5, 11], "nonsingular": [5, 8], "p": [5, 9, 10, 11, 12, 13, 14], "py": 5, "api": [5, 6], "recov": 5, "final": [5, 13], "ap": 5, "significantli": [5, 13, 14], "better": [5, 12], "revers": [5, 12, 13, 14], "commun": [5, 11, 12, 13, 14], "pz": 5, "tz": 5, "vector": [5, 10, 12, 13, 14], "av": 5, "tu": [5, 13, 14], "base": [5, 7, 9, 10, 11, 12, 13, 14], "golub": 5, "kahan": [5, 13, 14], "bidiagon": 5, "process": [5, 8, 11], "It": [5, 7, 10, 12, 13, 14], "equival": [5, 11], "appli": [5, 11, 12, 13, 14], "minr": 5, "ta": 5, "2i": 5, "tb": 5, "t": [5, 6, 10, 11, 12, 13, 14], "y": [5, 12, 13, 14], "ha": [5, 7, 8, 9, 10, 11, 12, 13, 14], "properti": [5, 10], "especi": [5, 11], "ill": 5, "rest": [5, 12, 13, 14], "bar": [5, 13, 14], "hspace": 5, "1cm": 5, "r": [5, 9, 13, 14], "releas": [5, 7, 8, 9, 12, 13, 14], "detail": [5, 9, 10, 11, 12, 13, 14], "changelog": [5, 9, 12, 14], "lsmr_solv": 5, "action": [5, 11], "u": [5, 9, 10, 11, 12, 13, 14], "v": [5, 10, 12, 13, 14], "keep": [5, 12, 13, 14], "option": [5, 7, 8, 9, 10, 11, 12, 13, 14], "upon": [5, 12, 13, 14], "return": [5, 7, 8, 9, 10, 11, 12, 13, 14], "task": [5, 11, 12, 13, 14], "recal": [5, 11, 12, 13, 14], "associ": [5, 10, 11, 12, 13, 14], "none": [5, 7, 8, 9, 10, 11, 12, 13, 14], "termin": [5, 10, 12, 13, 14], "reason": [5, 12, 14], "alter": [5, 7, 11], "apv": 5, "converg": [5, 10, 12, 13, 14], "continu": [5, 10, 11], "argument": [5, 8, 11], "inout": [5, 7, 8, 9, 11, 12, 13, 14], "tabl": [5, 8, 9, 10, 11, 12, 13, 14], "contain": [5, 6, 8, 9, 11, 12, 13, 14], "current": [5, 7, 10, 12, 13, 14], "lsmr_keep": 5, "privat": [5, 12, 13, 14], "intern": [5, 12, 13, 14], "lsmr_option": 5, "control": [5, 10, 12, 13, 14], "execut": [5, 10, 11, 14], "lsmr_inform": 5, "about": [5, 9, 10, 11, 12, 13, 14], "lsmr_free": 5, "stat": [5, 8, 10, 11, 12, 13, 14], "memori": [5, 9, 11, 12, 13, 14], "alloc": [5, 8, 9, 10, 11, 12, 13, 14], "unnecessari": [5, 12, 13, 14], "go": [5, 11, 12, 13, 14], "scope": [5, 11, 12, 13, 14], "freed": [5, 11, 12, 13, 14], "success": [5, 8, 9, 10, 11], "fail": [5, 8, 9, 10, 11, 13, 14], "dealloc": [5, 11], "seri": 5, "being": [5, 7, 13, 14], "sequenti": 5, "same": [5, 7, 10, 11, 12, 13, 14], "between": [5, 9, 12, 13, 14], "each": [5, 7, 8, 9, 10, 11, 12, 13, 14], "field": [5, 9, 10, 11, 12, 13, 14], "print_freq_head": 5, "20": [5, 7, 9, 10, 11, 12, 13, 14], "frequenc": 5, "print": [5, 6, 8, 9, 10, 11, 12, 13, 14], "head": 5, "line": [5, 9, 11, 12, 13, 14], "befor": [5, 7, 10, 11, 12, 13, 14], "reprint": 5, "print_freq_itn": 5, "statu": [5, 8, 10, 11, 12, 13, 14], "everi": 5, "unit_diagnost": [5, 11, 12, 14], "unit": [5, 9, 11, 12, 14], "diagnost": [5, 11, 12, 14], "suppress": [5, 11, 12, 14], "neg": [5, 11, 12, 13, 14], "unit_error": [5, 11, 12, 14], "error": [5, 8, 9, 10, 11, 12], "messag": [5, 11, 12, 14], "atol": 5, "sqrt": [5, 10, 12, 13, 14], "epsilon": [5, 10, 12, 14], "0d0": [5, 8, 9, 10, 11, 12, 13, 14], "rel": [5, 11, 12, 13, 14], "accur": [5, 12, 13, 14], "digit": 5, "0d": 5, "ctest": 5, "btol": 5, "conlim": 5, "cond": 5, "appar": 5, "norm": [5, 11, 12, 13, 14], "With": 5, "fond": 5, "saunder": 5, "itnlim": 5, "maximum": [5, 8, 9, 10, 11, 12, 14], "4n": 5, "itn_test": 5, "min": [5, 8, 11, 12], "locals": 5, "histor": 5, "reorthogon": 5, "progress": [5, 11, 12, 13, 14], "condap": 5, "veri": [5, 10, 12, 13, 14], "again": [5, 7, 11], "compon": [5, 10, 11, 12, 13, 14], "exit": [5, 8, 10, 11, 12, 13, 14], "below": [5, 8, 9, 10, 11, 12, 13, 14], "itn": 5, "normap": 5, "frobeniu": [5, 13, 14], "small": [5, 12, 13, 14], "been": [5, 7, 8, 10, 11, 12, 13, 14], "length": [5, 9, 11], "roughli": 5, "radic": 5, "residu": [5, 12, 13, 14], "normapr": 5, "often": 5, "smaller": [5, 13], "normr": 5, "normi": 5, "interpret": 5, "exact": [5, 11, 13], "No": [5, 11], "were": [5, 11, 12, 13, 14], "probabl": [5, 7], "given": [5, 8, 10, 11, 12, 13, 14], "present": [5, 8, 9, 10, 11], "exceed": [5, 12, 14], "appear": [5, 11], "enough": [5, 12, 13, 14], "machin": [5, 11, 13, 14], "too": [5, 13, 14], "larg": [5, 8, 9, 10, 11, 12, 13, 14], "reach": [5, 12, 14], "lmsr": 5, "f90": [5, 7, 8, 9, 10, 11, 12, 13, 14], "spral_lsmr_exampl": 5, "implicit": [5, 7, 8, 9, 10, 11, 12, 13, 14], "wp": [5, 8, 9, 10, 11, 12, 13, 14], "kind": [5, 7, 8, 9, 10, 11, 12, 13, 14], "rh": 5, "prepar": 5, "except": [5, 11], "switch": 5, "off": [5, 11, 12, 13, 14], "eq": [5, 7, 13, 14], "done": [5, 10], "i3": [5, 8, 12, 13, 14], "10f10": 5, "els": [5, 12, 13, 14], "matrix_mult_tran": 5, "matrix_mult": 5, "take": 5, "intent": [5, 12], "temp": 5, "0_wp": [5, 12], "output": [5, 7, 8, 9, 10, 11, 12, 13, 14], "26": 5, "17": [5, 11, 13, 14], "full": [5, 8, 10, 11], "approxim": [5, 10, 12, 13, 14], "certain": 5, "accuraci": [5, 12, 13], "poor": [5, 13], "therefor": [5, 12, 14], "unalt": [5, 11], "compar": [5, 12, 13, 14], "other": [5, 10, 11, 12, 13, 14], "correspond": [5, 10, 12, 13, 14], "up": [5, 11, 12, 14], "down": 5, "easili": 5, "unless": [5, 11], "known": [5, 12, 13, 14], "nonzero": 5, "thei": [5, 9, 11, 13, 14], "euclidean": [5, 12, 13, 14], "freedom": 5, "re": 5, "assign": [5, 8, 11, 12, 14], "after": [5, 7, 11], "attent": 5, "paid": 5, "intend": 5, "prevent": [5, 10, 12, 14], "anoth": 5, "aid": 5, "becom": [5, 10, 12, 13, 14], "x_0": [5, 7], "proce": [5, 10], "r_0": 5, "ax_0": 5, "delta": [5, 12, 14], "add": [5, 7, 8, 9], "correct": [5, 12, 13, 14], "guess": [5, 12, 13, 14], "judg": 5, "benefit": [5, 10, 12, 13, 14], "suppos": [5, 11], "k_1": 5, "k_2": 5, "stop": [5, 10, 12], "toler": [5, 10, 12, 13, 14], "similar": [5, 10, 11], "work": [5, 10, 12, 13, 14], "larger": [5, 12, 14], "second": [5, 9, 11], "mathrm": [5, 7, 10, 12, 14], "d": [5, 10, 11, 12, 13, 14], "fong": 5, "2011": 5, "siam": [5, 10, 12, 13, 14], "sci": 5, "33": 5, "2950": 5, "2971": 5, "1137": 5, "10079687x": 5, "assort": 6, "datatyp": 6, "storag": [6, 12, 13, 14], "convers": [6, 14], "09": [6, 7, 8, 9], "07": [6, 7], "still": [6, 13, 14], "redefinit": 6, "consid": [6, 11, 12, 14], "fix": [6, 10], "spral_matrix_unspecifi": 6, "doesn": 6, "spral_matrix_real_rect": 6, "spral_real_unsym": 6, "spral_real_sym_psdef": 6, "definit": [6, 8, 9, 10, 11, 12, 13, 14], "spral_real_sym_indef": 6, "spral_real_skew": 6, "skew": [6, 8, 9], "spral_matrix_cplx_rect": 6, "complex": [6, 9, 12, 13, 14], "spral_cplx_unsym": 6, "spral_cplx_herm_psdef": 6, "hermitian": [6, 9, 13, 14], "spral_cplx_sym_indef": 6, "spral_cplx_sym": 6, "spral_cplx_skew": 6, "congruenti": 7, "compliant": 7, "compil": [7, 11], "observ": 7, "486502": 7, "support": [7, 8, 9, 11, 12], "04": [7, 12], "initi": [7, 8, 9, 10, 12, 13, 14], "function": [7, 8, 12, 13, 14], "state": [7, 8, 9, 13, 14], "uniformli": [7, 9], "interv": 7, "fals": [7, 9, 10, 11, 13], "random_st": [7, 8, 9, 13, 14], "rng": 7, "logic": [7, 8, 9, 10, 11, 13, 14], "sampl": [7, 8], "largest": [7, 13], "match": [7, 8, 10, 11, 13, 14], "equal": [7, 8, 10, 12, 14], "random_get_se": 7, "stream": 7, "through": 7, "sequenc": [7, 11], "random_set_se": 7, "extract": 7, "subroutin": [7, 10], "new": [7, 8, 10, 11, 13, 14], "compont": 7, "examin": 7, "respect": [7, 12, 13, 14], "random_exampl": 7, "reus": 7, "later": 7, "f16": 7, "12": [7, 9, 11, 12, 13, 14], "unif": 7, "i16": 7, "huge": 7, "20_long": 7, "l16": 7, "restor": 7, "produc": [7, 8, 9, 10, 11, 12, 13, 14], "951878630556": 7, "395779648796": 7, "33572664025": 7, "f": [7, 12, 13, 14], "x_": 7, "ax_n": 7, "quad": 7, "mod": 7, "constant": 7, "1103515245": 7, "12345": 7, "31": 7, "accord": 7, "wikipedia": 7, "glibc": 7, "lcg": 7, "evolv": 7, "taken": [7, 10, 12, 14], "allow": [7, 9, 10, 11, 12, 13, 14], "x_n": 7, "frac": [7, 10, 12, 13, 14], "2x_n": 7, "ldot": [7, 13, 14], "int": 7, "densiti": [8, 12, 13, 14], "pattern": [8, 9, 11], "structur": [8, 10, 11], "degeneraci": 8, "ensur": [8, 9, 10, 12, 13, 14], "sort": 8, "within": [8, 11], "03": [8, 11], "06": [8, 11], "random_matrix_gener": 8, "nnz": 8, "half": 8, "One": [8, 9, 11, 12, 13, 14], "retangular": 8, "triangl": [8, 9], "made": 8, "domin": [8, 9], "singular": [8, 10, 11], "assur": 8, "regardless": 8, "algorithm": [8, 11, 12], "occur": [8, 13], "last": [8, 10, 12, 13, 14], "Such": [8, 12, 14], "guarante": [8, 10, 13, 14], "transvers": 8, "tt": [8, 13], "natur": [8, 12, 13, 14], "ascend": [8, 12, 13, 14], "invalid": [8, 9], "wa": [8, 11, 12, 14], "At": [8, 9, 10, 11], "less": [8, 11, 12, 14], "inconsist": 8, "request": [8, 9, 11, 12, 14], "also": [8, 9, 11, 12, 13, 14], "encourag": 8, "handl": [8, 14], "random_matrix": 8, "pkg": 8, "random_matrix_exampl": 8, "print_matrix": [8, 9, 10], "dimens": [8, 9, 10, 11, 12, 13, 14], "4x5": 8, "0744e": 8, "01": [8, 9, 10, 11, 12, 13, 14], "1000e": 8, "5364e": 8, "0912e": 8, "1631e": 8, "8957e": 8, "0631e": 8, "7313e": 8, "permut": [8, 10, 11, 12, 13, 14], "ad": [8, 10], "explicitli": [8, 14], "remain": [8, 11, 13, 14], "uniform": [8, 12], "weight": [8, 11], "proport": [8, 9, 10], "select": [8, 12, 13, 14], "alreadi": 8, "drawn": 8, "onc": [8, 11, 13, 14], "determin": [8, 9, 11, 12, 14], "insert": 8, "post": 8, "step": [8, 10, 11, 12, 13], "absolut": [8, 10, 12, 13, 14], "replac": [8, 10, 13, 14], "supplementari": 9, "hand": [9, 11, 13, 14], "side": [9, 11, 12, 13, 14], "mc55": 9, "mc56": 9, "charg": 9, "although": 9, "filenam": [9, 11], "nelt": 9, "nvar": 9, "nval": 9, "type_cod": 9, "identifi": [9, 11], "bore": 9, "header": 9, "access": [9, 13], "charact": 9, "len": 9, "element": [9, 13, 14], "defin": [9, 10, 13, 14], "distguish": 9, "three": [9, 12, 13, 14], "letter": 9, "72": [9, 13], "id": 9, "accept": [9, 12, 14], "instead": [9, 10, 12, 13, 14], "rb_read": 9, "allocat": [9, 13, 14], "Will": 9, "rb_read_opt": 9, "rb_write": 9, "overwritten": [9, 11], "rb_write_opt": 9, "Not": [9, 11, 12, 13, 14], "valid": [9, 11], "attempt": 9, "extra_spac": 9, "11": [9, 11, 12, 13, 14], "lwr_upr_ful": 9, "auxiliari": [9, 12, 14], "add_diagon": 9, "miss": [9, 11], "extra": [9, 12, 13, 14], "space": [9, 12, 14], "randomli": [9, 13, 14], "val_format": 9, "3e24": 9, "16": [9, 13, 14], "string": 9, "exce": [9, 10, 12, 13, 14], "80": [9, 12], "per": [9, 11, 13, 14], "automat": [9, 10, 11], "repres": 9, "rutherford_bo": 9, "rb_read_exampl": 9, "spral_matrix_real_sym_indef": [9, 10], "3a": 9, "trim": 9, "next": [9, 10, 12, 14], "5x5": [9, 10], "0000e": [9, 10], "00": [9, 10, 11, 12], "rb_write_exampl": 9, "rsa": 9, "40i2": 9, "2000000000000000e": 9, "1000000000000000e": 9, "4000000000000000e": 9, "8000000000000000e": 9, "3000000000000000e": 9, "max": [9, 10, 11, 12, 14], "100": [9, 10, 11, 12, 13, 14], "10k": 9, "report": [9, 10, 11, 12, 13, 14], "former": [9, 12, 13, 14], "encod": 9, "addit": [9, 11, 13, 14], "third": 9, "h": [9, 13], "z": [9, 13], "q": [9, 13, 14], "doe": [9, 13], "further": [9, 10, 11, 12, 13, 14], "duff": [9, 10], "grime": 9, "lewi": 9, "1997": [9, 10], "collect": 9, "ral": [9, 10, 11, 12, 13, 14], "technic": [9, 10, 11, 12, 13, 14], "tr": [9, 10, 11, 12, 13, 14], "97": 9, "031": 9, "variou": 10, "hat": [10, 13, 14], "dad": 10, "d_r": 10, "d_c": 10, "deliv": 10, "exactli": [10, 11], "cardin": 10, "slowli": 10, "wherea": 10, "quickli": 10, "infin": 10, "pm": 10, "tau": 10, "auction_scale_sym": 10, "auction_opt": 10, "auction_inform": 10, "unmatch": 10, "auction_scale_unsym": 10, "rscale": 10, "cscale": 10, "eps_initi": 10, "improv": [10, 11, 12, 13], "max_iter": [10, 12, 14], "30000": 10, "max_unchang": 10, "togeth": 10, "min_proport": 10, "give": [10, 11], "failur": [10, 11, 12, 13, 14], "design": [10, 11], "qualiti": [10, 11], "As": [10, 11], "defici": 10, "show": 10, "usag": 10, "auction_sym": 10, "auction_scale_sym_exampl": 10, "i5": 10, "endif": [10, 14], "10i10": 10, "10es10": 10, "calcul": [10, 12, 13, 14], "07e": 10, "62e": 10, "78e": 10, "80e": 10, "72e": 10, "1443e": 10, "0476e": 10, "5008e": 10, "02": [10, 11, 12, 13, 14], "3204e": 10, "1932e": 10, "fast": 10, "mc64": [10, 11], "dual": 10, "max_": 10, "sigma": [10, 12, 13, 14], "prod_": 10, "a_": 10, "ij": [10, 13], "sigma_": 10, "sum_": 10, "foral": [10, 12], "By": [10, 12, 14], "transform": [10, 12], "w_": 10, "log": 10, "c_j": 10, "max_i": 10, "minimum": [10, 11, 13, 14], "constraint": [10, 13], "satisfi": [10, 12, 14], "u_i": [10, 13, 14], "v_j": 10, "ge": 10, "r_i": 10, "c_i": 10, "v_i": 10, "averag": [10, 12, 13, 14], "d_i": 10, "r_id": 10, "le": [10, 13, 14], "maintain": [10, 13, 14], "along": [10, 12, 13, 14], "price": 10, "major": 10, "loop": [10, 12, 13, 14], "over": 10, "turn": [10, 12, 14], "p_i": 10, "across": 10, "previou": [10, 13, 14], "updat": [10, 12, 13, 14], "increment": 10, "shuffl": 10, "insist": 10, "threshold": [10, 11], "ep": 10, "_initi": 10, "itr": 10, "satsifi": 10, "combin": [10, 11, 12, 14], "wide": 10, "heurist": 10, "On": [10, 11, 13], "002": 10, "equilib_scale_sym": 10, "equilib_opt": 10, "equilib_inform": 10, "equilib_scale_unsym": 10, "tol": [10, 13], "1e": [10, 13], "equilib_sym": 10, "equilib_scale_sym_exampl": 10, "54e": 10, "77e": 10, "66e": 10, "5000e": 10, "0412e": 10, "9960e": 10, "mc77": [10, 11], "asymptot": [10, 13], "rate": 10, "preserv": 10, "symmetri": 10, "outlin": [10, 13], "_": [10, 13, 14], "ii": [10, 11, 12, 13, 14], "max_j": 10, "jj": 10, "skip": 10, "knight": 10, "ruiz": [10, 11], "ucar": 10, "2012": 10, "inria": 10, "research": 10, "7552": 10, "hungarian_scale_sym": 10, "hungarian_opt": 10, "hungarian_inform": 10, "hungarian_scale_unsym": 10, "scale_if_singular": 10, "partial": [10, 11], "ident": [10, 13], "maxim": [10, 13, 14], "extrem": [10, 12, 13, 14], "care": 10, "shuold": 10, "meaning": 10, "warn": [10, 11, 12, 14], "hungarian_sym": 10, "hungarian_scale_sym_exampl": 10, "22e": 10, "59e": 10, "40e": 10, "39e": 10, "74e": 10, "2500e": 10, "8571e": 10, "dure": [10, 11], "subset": 10, "grow": 10, "augment": 10, "slow": [10, 12, 13, 14], "explor": 10, "warmstart": 10, "construct": [10, 11], "koster": 10, "anal": [10, 11, 12, 13, 14], "applic": 10, "pp": 10, "889": 10, "901": 10, "journal": 10, "preprint": [10, 11], "multifront": 11, "cover": 11, "ssid": 11, "pld": 11, "pl": 11, "block": [11, 12, 13, 14], "choleski": 11, "primarili": 11, "dedic": 11, "hybrid": [11, 13, 14], "nvidia": 11, "overlin": 11, "four": 11, "stage": 11, "ssids_analys": 11, "symbol": 11, "akeep": 11, "ssids_factor": 11, "fkeep": 11, "ssids_solv": 11, "ssids_fre": 11, "ssids_enquire_posdef": 11, "ssids_enquire_indef": 11, "pivot": [11, 12], "ssids_alt": 11, "bla": [11, 13, 14], "That": 11, "consecut": 11, "topologi": 11, "analys": 11, "phase": 11, "subsequ": 11, "drop": [11, 13], "ssids_akeep": 11, "unchang": 11, "ssids_opt": 11, "ssids_inform": 11, "actual": [11, 12, 13, 14], "numa_region": 11, "exploit": 11, "independ": [11, 12, 13, 14], "numa": 11, "region": 11, "nproc": 11, "thread": 11, "auto": 11, "librari": 11, "environ": 11, "omp_num_thread": 11, "divid": [11, 13, 14], "origin": 11, "supernod": 11, "amalgam": 11, "topograph": 11, "assembli": 11, "tree": 11, "adjust": [11, 13, 14], "cach": 11, "backward": [11, 12, 13, 14], "ssids_analyse_coord": 11, "variant": 11, "posdef": 11, "preced": 11, "ssids_fkeep": 11, "s_": 11, "sinc": 11, "job": [11, 12, 13, 14], "singl": 11, "absent": 11, "plx": 11, "sb": 11, "sa": 11, "nrh": 11, "ldx": [11, 12], "multipl": [11, 13, 14], "lead": [11, 12, 13], "cuda_error": 11, "mere": 11, "them": [11, 12, 13, 14], "leak": 11, "due": 11, "underli": 11, "mechan": 11, "l_": 11, "piv_ord": 11, "texttt": 11, "sign": 11, "times1": 11, "part": 11, "times2": 11, "d_": 11, "print_level": [11, 12, 14], "level": [11, 13, 14], "plu": [11, 12, 14], "unit_warn": [11, 12, 14], "meti": 11, "elimin": 11, "hungarian": 11, "restrict": 11, "forc": 11, "subdiagon": 11, "nemin": 11, "two": [11, 12, 13, 14], "neighbour": 11, "merg": 11, "involv": 11, "fewer": [11, 12, 13, 14], "ignore_numa": 11, "cpu": [11, 12, 13, 14], "treat": [11, 12, 14], "belong": [11, 14], "use_gpu": 11, "min_gpu_work": 11, "5e9": 11, "flop": 11, "schedul": 11, "max_load_inbal": 11, "load": 11, "inbal": 11, "gpu_perf_coeff": 11, "coeffici": [11, 14], "faster": 11, "bipartit": 11, "via": [11, 12], "auction": 11, "consider": [11, 12, 14], "analysi": 11, "equilibr": 11, "small_subtree_threshold": 11, "4e6": 11, "cpu_block_s": 11, "256": 11, "parallel": [11, 14], "node": 11, "discoveri": 11, "abort": 11, "pivot_method": 11, "aggress": 11, "posteori": 11, "like": 11, "restart": [11, 12, 13, 14], "potenti": 11, "recalcul": 11, "unelimin": 11, "own": [11, 13], "1d": 11, "outsid": 11, "closest": 11, "cpu_flop": 11, "cublas_error": 11, "cubla": 11, "asynchron": 11, "gpu_flop": 11, "matrix_dup": 11, "encount": 11, "matrix_missing_diag": 11, "explicit": [11, 12], "matrix_outrang": 11, "matrix_rank": 11, "estim": [11, 12], "maxdepth": 11, "maxfront": 11, "front": 11, "maxsupernod": 11, "num_delai": 11, "delai": 11, "fulli": 11, "father": 11, "becaus": [11, 12, 13, 14], "stabil": 11, "count": [11, 12], "num_factor": 11, "num_flop": 11, "indefint": 11, "slightli": 11, "num_neg": 11, "eigenvalu": [11, 12, 13, 14], "num_sup": 11, "num_two": 11, "14": [11, 13, 14], "15": [11, 13, 14], "50": 11, "51": 11, "52": 11, "53": 11, "openmp": 11, "cancel": 11, "disabl": 11, "omp_cancel": 11, "overwrit": 11, "effect": [11, 12, 14], "processor": 11, "bind": 11, "omp_proc_bind": 11, "affect": [11, 13], "19": [11, 12, 13, 14], "ssids_exampl": 11, "factoris": 11, "3es18": 11, "10i5": 11, "0000000000e": 11, "ship": 11, "read": 11, "rutherford": 11, "boe": 11, "configur": 11, "assum": [11, 13], "app": 11, "tpp": 11, "flat": 11, "don": 11, "perf": 11, "coeff": 11, "ngpu": 11, "linvers": 11, "ok": 11, "devic": 11, "took": [11, 12], "20000011e": 11, "predict": 11, "nfact": 11, "03e": 11, "nflop": 11, "25e": 11, "npart": 11, "cpu_fl": 11, "gpu_fl": 11, "00e": [11, 12], "20000001e": 11, "00000005e": 11, "bad": 11, "cmp": 11, "fwd": 11, "_inf": 11, "8014036363165360e": 11, "013": 11, "bwd": 11, "2549737582555113e": 11, "015": 11, "smfct": 11, "fact": 11, "afact": 11, "aflop": 11, "inerti": 11, "2838": 11, "9161": 11, "2x2piv": 11, "5502": 11, "maxfro": 11, "55": 11, "maxsup": 11, "not_fi": 11, "not_s": 11, "broken": 11, "root": 11, "leav": [11, 13], "forest": 11, "pre": 11, "cooper": 11, "serial": 11, "clean": 11, "discard": 11, "incur": 11, "overhead": 11, "unpredict": 11, "enter": 11, "term": [11, 12, 13, 14], "fill": [11, 13, 14], "though": 11, "kept": 11, "close": [11, 13, 14], "vari": 11, "kernel": 11, "choos": 11, "emploi": [11, 12, 13, 14], "would": 11, "articl": 11, "2756548": 11, "006": 11, "ldlt": [11, 12], "posteriori": 11, "0xx": 11, "leftmost": [12, 13, 14], "rightmost": [12, 13, 14], "eigenpair": [12, 13, 14], "lambda_i": [12, 13, 14], "x_i": [12, 13, 14], "buckl": [12, 13, 14], "friendli": [12, 13, 14], "wrapper": [12, 14], "around": [12, 14], "fine": 12, "tune": 12, "2015": 12, "behind": [12, 14], "highli": [12, 13, 14], "ubiquit": [12, 13, 14], "multicor": [12, 13, 14], "reliabl": [12, 13, 14], "krylov": [12, 13, 14], "arpack": [12, 13, 14], "presenc": [12, 13, 14], "cluster": [12, 13, 14], "spectrum": [12, 13, 14], "thu": [12, 13, 14], "speed": [12, 13, 14], "conting": [12, 13, 14], "factor": [12, 13], "substanti": [12, 13, 14], "employ": [12, 13, 14], "acceler": [12, 13, 14], "techniqu": [12, 13, 14], "hsl_ma97": [12, 14], "simpl": [12, 13, 14], "experienc": [12, 13, 14], "ssmfe_standard": [12, 14], "rci": [12, 13, 14], "mep": [12, 13, 14], "fatal": [12, 13, 14], "complet": [12, 13, 14], "tx": [12, 14], "ssmfe_rcid": [12, 13, 14], "ssmfe_rciz": [12, 13, 14], "guidanc": [12, 14], "eigenvector": [12, 13], "user_x": [12, 13, 14], "ssmfe_keepd": 12, "workspac": [12, 13, 14], "ssmfe_keepz": 12, "ssmfe_opt": [12, 14], "ssmfe_inform": [12, 13, 14], "exect": [12, 13, 14], "ssmfe_standard_shift": [12, 14], "vicin": [12, 14], "ssmfe_gener": [12, 14], "bx": [12, 13, 14], "ssmfe_generalized_shift": [12, 14], "ssmfe_buckl": [12, 14], "ssmfe_fre": [12, 13, 14], "nx": [12, 13, 14], "abs_tol_lambda": [12, 14], "ssmfe": [12, 13, 14], "abs_tol_residu": [12, 14], "rel_tol_lambda": [12, 14], "rel_tol_residu": [12, 14], "tol_x": [12, 14], "amount": [12, 13, 14], "subspac": [12, 13, 14], "start": [12, 13, 14], "far": [12, 14], "rough": [12, 14], "criteria": 12, "few": [12, 14], "left_gap": [12, 14], "distanc": [12, 13, 14], "explan": [12, 14], "max_left": [12, 14], "max_right": [12, 14], "right_gap": [12, 14], "linerali": [12, 14], "next_left": [12, 14], "next_right": [12, 14], "non_converg": [12, 13, 14], "200": [12, 13, 14], "linearli": [12, 13, 14], "happen": [12, 13, 14], "round": [12, 13, 14], "essenti": [12, 13, 14], "had": [12, 14], "gap": [12, 14], "info": 12, "advanc": [12, 14], "procedur": [12, 13, 14], "deleg": 12, "dimension": [12, 13, 14], "laplacian": [12, 13, 14], "grid": [12, 13, 14], "forward": [12, 13, 14], "gauss": [12, 13, 14], "seidel": [12, 13, 14], "halv": [12, 13, 14], "laplace2d": [12, 13, 14], "apply_laplacian": [12, 13, 14], "multipli": [12, 13, 14], "apply_gauss_seidel_step": [12, 13, 14], "precond_ssmf": 12, "ssmfe_precond_exampl": 12, "lapalacian": [12, 14], "nep": [12, 13, 14], "want": [12, 13, 14], "1x": [12, 13, 14], "i2": [12, 14], "es13": [12, 14], "4676695e": [12, 13, 14], "1119274e": [12, 13, 14], "7770878e": [12, 13, 14], "2040061e": [12, 13, 14], "insuffici": [12, 14], "5th": [12, 14], "6th": [12, 14], "dsytr": 12, "dsytrf": 12, "discret": [12, 14], "set_2d_laplacian_matrix": 12, "ldltf": 12, "num_neg_d": 12, "shift_invert": 12, "ssmfe_shift_invert_exampl": 12, "ny": [12, 13, 14], "ipiv": 12, "lwork": 12, "set_laplacian_matrix": 12, "dgemm": [12, 13, 14], "dcopi": [12, 13, 14], "es10": 12, "4122952e": 12, "8852587e": 12, "3582223e": 12, "1206148e": 12, "4679111e": 12, "7733184e": 12, "differenti": [12, 14], "act": 12, "period": 12, "central": 12, "mesh": 12, "ssmfe_hermitian_exampl": 12, "apply_idx": 12, "es14": [12, 13], "im_on": 12, "il": 12, "ir": 12, "0000000e": 12, "9938347e": 12, "9753767e": 12, "built": 12, "jacobi": [12, 13, 14], "conjug": [12, 13, 14], "gradient": [12, 13, 14], "jcpg": [12, 13], "simultan": [12, 13], "n_e": 12, "sake": 12, "ab": [12, 13, 14], "_tol": [12, 14], "_lambda": [12, 14], "sine": [12, 14], "angl": [12, 14], "invari": [12, 13, 14], "_residu": [12, 14], "role": [12, 14], "pure": [12, 14], "low": [12, 13, 14], "delta_l": [12, 14], "delta_r": [12, 14], "These": [12, 13, 14], "littl": [12, 14], "might": [12, 14], "notabl": [12, 13, 14], "safeguard": [12, 14], "import": [12, 13, 14], "ldl": [12, 14], "inertia": [12, 14], "theorem": [12, 14], "quick": [12, 14], "reid": [12, 13, 14], "2010": [12, 13, 14], "46": [12, 13, 14], "2567": [12, 13, 14], "2592": [12, 13, 14], "sever": [12, 13, 14], "2593": [12, 13, 14], "2619": [12, 13, 14], "simplifi": [13, 14], "featur": 13, "shift": 13, "invert": [13, 14], "rewrit": 13, "mu": 13, "futher": 13, "whilst": 13, "manag": 13, "respons": 13, "decid": 13, "uffici": 13, "facilit": [13, 14], "share": 13, "kw": [13, 14], "notat": [13, 14], "convieni": [13, 14], "w": [13, 14], "minaprod": [13, 14], "minbprod": [13, 14], "standard_shift": [13, 14], "generalized_shift": [13, 14], "generalis": [13, 14], "imag": [13, 14], "separ": [13, 14], "reorthagonalis": [13, 14], "whenev": 13, "move": 13, "rr": [13, 14], "ind": [13, 14], "au": [13, 14], "bu": [13, 14], "err_lambda": [13, 14], "err_x": [13, 14], "jx": [13, 14], "kx": [13, 14], "save": [13, 14], "ky": [13, 14], "reorder": [13, 14], "dot": [13, 14], "r_": [13, 14], "cdot": [13, 14], "_i": [13, 14], "alpha": [13, 14], "beta": [13, 14], "21": [13, 14], "orthogon": [13, 14], "tbx": [13, 14], "xq": [13, 14], "math": 13, "bxq": [13, 14], "22": [13, 14], "999": [13, 14], "suggest": [13, 14], "entir": [13, 14], "jy": [13, 14], "abx": 13, "ssmfe_core_keep": 13, "ssmfe_core_opt": 13, "ssmfe_largest": 13, "ssmfe_expert_keep": [13, 14], "err_est": [13, 14], "scheme": [13, 14], "modifi": [13, 14], "davi": [13, 14], "lehmann": [13, 14], "eigenval": [13, 14], "curv": [13, 14], "extra_left": [13, 14], "enhanc": [13, 14], "extra_right": [13, 14], "min_gap": [13, 14], "sensit": 13, "margin": 13, "ever": 13, "cf_max": 13, "stagnat": [13, 14], "q_": 13, "greater": 13, "mark": 13, "ssmfe_infrom": 13, "residual_norm": [13, 14], "incompat": [13, 14], "precond_cor": 13, "ssmfe_core_precond_exampl": 13, "prng": [13, 14], "extern": [13, 14], "dnrm2": [13, 14], "ddot": [13, 14], "ncon": [13, 14], "lmd": 13, "lin": [13, 14], "indep": [13, 14], "random_r": [13, 14], "dscal": [13, 14], "e14": 13, "2e10": 13, "cycl": [13, 14], "250": 13, "daxpi": [13, 14], "i1": 13, "subr": 13, "simplic": 13, "matlab": 13, "rayleigh": 13, "ritz": [13, 14], "trial": 13, "span": 13, "pencil": 13, "main": 13, "accordingli": 13, "empti": 13, "project": 13, "onto": 13, "remov": 13, "until": 13, "fall": 13, "place": 13, "deal": 13, "constrain": 13, "unconstrain": 13, "5c": 13, "quotient": 13, "smallest": [13, 14], "cleanup": 13, "_sygv": 13, "unaccept": 13, "practic": 13, "rare": 13, "sought": 13, "tild": [13, 14], "lambda_k": [13, 14], "s_k": [13, 14], "lambda_j": [13, 14], "r_j": [13, 14], "x_j": [13, 14], "lambda_": [13, 14], "unknown": [13, 14], "pollut": [13, 14], "delta_j": [13, 14], "approx": [13, 14], "inequ": [13, 14], "min_": [13, 14], "mathcal": [13, 14], "sin": [13, 14], "decrement": [13, 14], "facotr": 13, "geometr": 13, "reduct": [13, 14], "unlik": [13, 14], "mention": [13, 14], "kinemat": [13, 14], "demonstr": [13, 14], "closer": [13, 14], "furthermor": [13, 14], "straightforwardli": [13, 14], "well": [13, 14], "beta_1": [13, 14], "precond": 14, "precond_expert": 14, "ssmfe_expert_precond_exampl": 14, "ngrid": 14, "dimn": 14, "i4": 14, "129": 14, "align": 14, "label": 14, "mx": 14, "yield": 14, "overestim": 14, "strong": 14}, "objects": {"": [[9, 0, 1, "", "f/_/rb_peek"], [9, 0, 1, "", "f/_/rb_read"], [9, 1, 1, "", "f/_/rb_read_options"], [9, 0, 1, "", "f/_/rb_write"], [9, 1, 1, "", "f/_/rb_write_options"], [5, 2, 1, "", "f/spral_lsmr"], [5, 0, 1, "", "f/spral_lsmr/lsmr_free"], [5, 1, 1, "", "f/spral_lsmr/lsmr_inform"], [5, 1, 1, "", "f/spral_lsmr/lsmr_options"], [5, 0, 1, "", "f/spral_lsmr/lsmr_solve"], [6, 2, 1, "", "f/spral_matrix_util"], [7, 2, 1, "", "f/spral_random"], [7, 3, 1, "", "f/spral_random/random_get_seed"], [7, 3, 1, "", "f/spral_random/random_integer"], [7, 3, 1, "", "f/spral_random/random_logical"], [7, 3, 1, "", "f/spral_random/random_real"], [7, 0, 1, "", "f/spral_random/random_set_seed"], [7, 1, 1, "", "f/spral_random/random_state"], [8, 2, 1, "", "f/spral_random_matrix"], [8, 3, 1, "", "f/spral_random_matrix/random_matrix_generate"], [10, 2, 1, "", "f/spral_scaling"], [10, 1, 1, "", "f/spral_scaling/auction_inform"], [10, 1, 1, "", "f/spral_scaling/auction_options"], [10, 0, 1, "", "f/spral_scaling/auction_scale_sym"], [10, 0, 1, "", "f/spral_scaling/auction_scale_unsym"], [10, 1, 1, "", "f/spral_scaling/equilib_inform"], [10, 1, 1, "", "f/spral_scaling/equilib_options"], [10, 0, 1, "", "f/spral_scaling/equilib_scale_sym"], [10, 0, 1, "", "f/spral_scaling/equilib_scale_unsym"], [10, 1, 1, "", "f/spral_scaling/hungarian_inform"], [10, 1, 1, "", "f/spral_scaling/hungarian_options"], [10, 0, 1, "", "f/spral_scaling/hungarian_scale_sym"], [10, 0, 1, "", "f/spral_scaling/hungarian_scale_unsym"], [11, 2, 1, "", "f/spral_ssids"], [11, 0, 1, "", "f/spral_ssids/ssids_alter"], [11, 0, 1, "", "f/spral_ssids/ssids_analyse"], [11, 0, 1, "", "f/spral_ssids/ssids_analyse_coord"], [11, 0, 1, "", "f/spral_ssids/ssids_enquire_indef"], [11, 0, 1, "", "f/spral_ssids/ssids_enquire_posdef"], [11, 0, 1, "", "f/spral_ssids/ssids_factor"], [11, 0, 1, "", "f/spral_ssids/ssids_free"], [11, 1, 1, "", "f/spral_ssids/ssids_inform"], [11, 1, 1, "", "f/spral_ssids/ssids_options"], [11, 0, 1, "", "f/spral_ssids/ssids_solve"], [12, 2, 1, "", "f/spral_ssmfe"], [12, 0, 1, "", "f/spral_ssmfe/ssmfe_buckling"], [12, 0, 1, "", "f/spral_ssmfe/ssmfe_free"], [12, 0, 1, "", "f/spral_ssmfe/ssmfe_generalized"], [12, 0, 1, "", "f/spral_ssmfe/ssmfe_generalized_shift"], [12, 1, 1, "", "f/spral_ssmfe/ssmfe_inform"], [12, 1, 1, "", "f/spral_ssmfe/ssmfe_options"], [12, 1, 1, "", "f/spral_ssmfe/ssmfe_rcid"], [12, 1, 1, "", "f/spral_ssmfe/ssmfe_rciz"], [12, 0, 1, "", "f/spral_ssmfe/ssmfe_standard"], [12, 0, 1, "", "f/spral_ssmfe/ssmfe_standard_shift"], [13, 2, 1, "", "f/spral_ssmfe_core"], [13, 0, 1, "", "f/spral_ssmfe_core/ssmfe"], [13, 1, 1, "", "f/spral_ssmfe_core/ssmfe_core_options"], [13, 0, 1, "", "f/spral_ssmfe_core/ssmfe_free"], [13, 1, 1, "", "f/spral_ssmfe_core/ssmfe_infrom"], [13, 0, 1, "", "f/spral_ssmfe_core/ssmfe_largest"], [14, 2, 1, "", "f/spral_ssmfe_expert"], [14, 0, 1, "", "f/spral_ssmfe_expert/ssmfe_buckling"], [14, 0, 1, "", "f/spral_ssmfe_expert/ssmfe_free"], [14, 0, 1, "", "f/spral_ssmfe_expert/ssmfe_generalized"], [14, 0, 1, "", "f/spral_ssmfe_expert/ssmfe_generalized_shift"], [14, 1, 1, "", "f/spral_ssmfe_expert/ssmfe_inform"], [14, 1, 1, "", "f/spral_ssmfe_expert/ssmfe_options"], [14, 1, 1, "", "f/spral_ssmfe_expert/ssmfe_rcid"], [14, 1, 1, "", "f/spral_ssmfe_expert/ssmfe_rciz"], [14, 0, 1, "", "f/spral_ssmfe_expert/ssmfe_standard"], [14, 0, 1, "", "f/spral_ssmfe_expert/ssmfe_standard_shift"], [5, 2, 0, "-", "spral_lsmr"], [6, 2, 0, "-", "spral_matrix_util"], [7, 2, 0, "-", "spral_random"], [8, 2, 0, "-", "spral_random_matrix"], [10, 2, 0, "-", "spral_scaling"], [11, 2, 0, "-", "spral_ssids"], [12, 2, 0, "-", "spral_ssmfe"], [13, 2, 0, "-", "spral_ssmfe_core"], [14, 2, 0, "-", "spral_ssmfe_expert"]]}, "objtypes": {"0": "f:subroutine", "1": "f:type", "2": "f:module", "3": "f:function"}, "objnames": {"0": ["f", "subroutine", "Fortran subroutine"], "1": ["f", "type", "Fortran type"], "2": ["f", "module", "Fortran module"], "3": ["f", "function", "Fortran function"]}, "titleterms": {"data": [0, 7, 10, 11], "type": [0, 5, 6, 7, 9, 10, 11, 12, 13, 14], "convent": 0, "option": [0, 4], "argument": 0, "coordin": 1, "coord": 1, "format": [1, 2, 9], "compress": 2, "spars": [2, 3, 5, 10, 11, 12, 13, 14], "column": 2, "csc": 2, "The": [3, 13, 14], "parallel": 3, "robust": 3, "algorithm": [3, 5, 10, 13, 14], "librari": [3, 4], "indic": 3, "tabl": 3, "instal": 4, "build": 4, "meson": 4, "autotool": 4, "note": 4, "third": 4, "parti": 4, "meti": 4, "bla": 4, "compil": 4, "other": 4, "configur": 4, "cite": 4, "spral": 4, "ssid": 4, "support": 4, "licenc": 4, "spral_lsmr": 5, "least": 5, "squar": 5, "lsmr": 5, "solver": [5, 11], "purpos": [5, 6, 7, 8, 9, 11, 12, 13, 14], "notat": 5, "version": [5, 6, 7, 8, 9, 12, 13, 14], "histori": [5, 6, 7, 8, 9, 12, 13, 14], "subroutin": [5, 9, 11, 12, 13, 14], "deriv": [5, 9, 11, 12, 13, 14], "exampl": [5, 7, 8, 9, 10, 11, 12, 13, 14], "method": [5, 7, 8, 9, 10, 11, 12, 13, 14], "scale": [5, 10], "initi": 5, "estim": [5, 13, 14], "refer": [5, 11, 12, 13, 14], "spral_matrix_util": 6, "matrix": [6, 8, 9, 10, 12, 13, 14], "util": [6, 9], "code": [6, 9], "spral_random": 7, "pseudo": [7, 8], "random": [7, 8, 9], "number": 7, "gener": [7, 8, 9, 13, 14], "routin": [7, 8, 10], "get": 7, "set": 7, "seed": 7, "In": 7, "random_r": 7, "random_integ": 7, "random_log": 7, "spral_random_matrix": 8, "spral_rutherford_bo": 9, "rb": 9, "file": 9, "exit": 9, "statu": 9, "read": 9, "write": 9, "valu": 9, "rutherford": 9, "boe": 9, "spral_scal": 10, "auction": 10, "norm": 10, "equilibr": 10, "hungarian": 10, "spral_ssid": 11, "symmetr": [11, 12, 13, 14], "indefinit": 11, "direct": 11, "usag": [11, 12, 13, 14], "overview": [11, 12, 13, 14], "basic": 11, "advanc": 11, "driver": 11, "program": 11, "partit": 11, "work": 11, "across": 11, "avail": 11, "resourc": 11, "check": 11, "factor": [11, 14], "perform": 11, "small": 11, "leaf": 11, "subtre": 11, "spral_ssmf": 12, "free": [12, 13, 14], "eigensolv": [12, 13, 14], "precondit": [12, 13, 14], "shift": [12, 14], "invert": 12, "hermitian": 12, "spral_ssmfe_cor": 13, "core": 13, "major": [13, 14], "error": [13, 14], "standard": [13, 14], "problem": [13, 14], "spral_ssmfe_expert": 14, "expert": 14, "interfac": 14, "stop": 14, "criteria": 14, "improv": 14, "eigenvector": 14, "accuraci": 14, "us": 14}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 8, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx": 57}, "alltitles": {"Data types and conventions": [[0, "data-types-and-conventions"]], "Data types": [[0, "data-types"]], "Optional arguments": [[0, "optional-arguments"]], "Coordinate (Coord) Format": [[1, "coordinate-coord-format"]], "Compressed Sparse Column (CSC) Format": [[2, "compressed-sparse-column-csc-format"]], "The Sparse Parallel Robust Algorithms Library": [[3, "the-sparse-parallel-robust-algorithms-library"]], "Indices and tables": [[3, "indices-and-tables"]], "Installation": [[4, "installation"]], "Building with Meson:": [[4, "building-with-meson"]], "Options to meson": [[4, "options-to-meson"]], "Building with Autotools:": [[4, "building-with-autotools"]], "Notes": [[4, "notes"]], "Third-party libraries": [[4, "third-party-libraries"]], "METIS": [[4, "metis"]], "BLAS": [[4, "blas"]], "Compilers and compiler options": [[4, "compilers-and-compiler-options"]], "Other options to configure": [[4, "other-options-to-configure"]], "Citing SPRAL or SSIDS": [[4, "citing-spral-or-ssids"]], "Support": [[4, "support"]], "Licence": [[4, "licence"]], "spral_lsmr - Sparse Least Squares LSMR Solver": [[5, "f/spral_lsmr"]], "Purpose": [[5, "purpose"], [6, "purpose"], [7, "purpose"], [8, "purpose"], [9, "purpose"], [11, "purpose"], [12, "purpose"], [13, "purpose"], [14, "purpose"]], "Notation": [[5, "notation"]], "Version history": [[5, "version-history"], [6, "version-history"], [7, "version-history"], [8, "version-history"], [9, "version-history"], [12, "version-history"]], "Subroutines": [[5, "subroutines"], [9, "subroutines"], [12, "subroutines"], [13, "subroutines"], [14, "subroutines"]], "Derived types": [[5, "derived-types"], [9, "derived-types"], [11, "derived-types"], [12, "derived-types"], [13, "derived-types"], [14, "derived-types"]], "Example": [[5, "example"], [7, "example"], [8, "example"], [9, "example"], [10, "example"], [10, "id5"], [10, "id11"], [11, "example"]], "Method": [[5, "method"], [7, "method"], [8, "method"], [9, "method"], [10, "method"], [10, "equilib-algorithm-method"], [10, "hungarian-algorithm-method"], [11, "method"], [12, "method"], [13, "method"], [14, "method"]], "Algorithm": [[5, "algorithm"]], "Scaling": [[5, "scaling"]], "Initial estimate": [[5, "initial-estimate"]], "References": [[5, "references"], [11, "references"], [12, "references"], [13, "references"], [14, "references"]], "spral_matrix_util - Matrix utilities": [[6, "f/spral_matrix_util"]], "Matrix type codes": [[6, "matrix-type-codes"]], "spral_random - Pseudo-random number generator": [[7, "f/spral_random"]], "Routines": [[7, "routines"], [8, "routines"], [10, "routines"], [10, "id3"], [10, "id9"]], "Random Number Generation": [[7, "random-number-generation"]], "Get/Set Random Seed": [[7, "get-set-random-seed"]], "Data Types": [[7, "data-types"]], "In random_real()": [[7, "in-random-real"]], "In random_integer()": [[7, "in-random-integer"]], "In random_logical()": [[7, "in-random-logical"]], "spral_random_matrix - Pseudo-random Matrix Generator": [[8, "f/spral_random_matrix"]], "spral_rutherford_boeing - RB File Format Utilities": [[9, "spral-rutherford-boeing-rb-file-format-utilities"]], "Exit status codes": [[9, "exit-status-codes"], [9, "exit-status"]], "Reading a matrix": [[9, "reading-a-matrix"]], "Writing a matrix": [[9, "writing-a-matrix"]], "Generation of random values": [[9, "generation-of-random-values"]], "Rutherford Boeing File format": [[9, "rutherford-boeing-file-format"]], "Type code": [[9, "type-code"]], "spral_scaling - Sparse matrix scalings": [[10, "f/spral_scaling"]], "Auction Algorithm": [[10, "auction-algorithm"]], "Data-types": [[10, "data-types"], [10, "id4"], [10, "id10"]], "Norm-equilibration Algorithm": [[10, "norm-equilibration-algorithm"]], "Hungarian Algorithm": [[10, "hungarian-algorithm"]], "spral_ssids - Sparse Symmetric Indefinite Direct Solver": [[11, "f/spral_ssids"]], "Usage overview": [[11, "usage-overview"], [12, "usage-overview"], [13, "usage-overview"], [14, "usage-overview"]], "Basic Subroutines": [[11, "basic-subroutines"]], "Advanced subroutines": [[11, "advanced-subroutines"]], "Driver Program": [[11, "driver-program"]], "Partition of work across available resources": [[11, "partition-of-work-across-available-resources"]], "Data checking": [[11, "data-checking"]], "Factorization performed": [[11, "factorization-performed"]], "Small Leaf Subtrees": [[11, "small-leaf-subtrees"]], "spral_ssmfe - Sparse Symmetric Matrix-Free Eigensolver": [[12, "f/spral_ssmfe"]], "Examples": [[12, "examples"], [13, "examples"], [14, "examples"]], "Preconditioning example": [[12, "preconditioning-example"], [13, "preconditioning-example"], [14, "preconditioning-example"]], "Shift-and-invert example": [[12, "shift-and-invert-example"]], "Hermitian example": [[12, "hermitian-example"]], "spral_ssmfe_core - Sparse Symmetric Matrix-Free Eigensolver (Core Algorithm)": [[13, "f/spral_ssmfe_core"]], "Major version history": [[13, "major-version-history"], [14, "major-version-history"]], "The algorithm": [[13, "the-algorithm"], [14, "the-algorithm"]], "Error estimation": [[13, "error-estimation"], [14, "error-estimation"]], "Standard problem": [[13, "standard-problem"], [14, "standard-problem"]], "Generalized problems": [[13, "generalized-problems"]], "spral_ssmfe_expert - Sparse Symmetric Matrix-Free Eigensolver (Expert interface)": [[14, "f/spral_ssmfe_expert"]], "Stopping criteria": [[14, "stopping-criteria"]], "Improving eigenvector accuracy": [[14, "improving-eigenvector-accuracy"]], "The use of shifted matrix factorization": [[14, "the-use-of-shifted-matrix-factorization"]], "Generalized problem": [[14, "generalized-problem"]]}, "indexentries": {"lsmr_free() (fortran subroutine)": [[5, "f/spral_lsmr/lsmr_free"]], "lsmr_inform (fortran type)": [[5, "f/spral_lsmr/lsmr_inform"]], "lsmr_options (fortran type)": [[5, "f/spral_lsmr/lsmr_options"]], "lsmr_solve() (fortran subroutine)": [[5, "f/spral_lsmr/lsmr_solve"]], "spral_lsmr (module)": [[5, "f/spral_lsmr"]], "spral_matrix_util (module)": [[6, "f/spral_matrix_util"]], "random_get_seed() (fortran function)": [[7, "f/spral_random/random_get_seed"]], "random_integer() (fortran function)": [[7, "f/spral_random/random_integer"]], "random_logical() (fortran function)": [[7, "f/spral_random/random_logical"]], "random_real() (fortran function)": [[7, "f/spral_random/random_real"]], "random_set_seed() (fortran subroutine)": [[7, "f/spral_random/random_set_seed"]], "random_state (fortran type)": [[7, "f/spral_random/random_state"]], "spral_random (module)": [[7, "f/spral_random"]], "random_matrix_generate() (fortran function)": [[8, "f/spral_random_matrix/random_matrix_generate"]], "spral_random_matrix (module)": [[8, "f/spral_random_matrix"]], "rb_peek() (fortran subroutine)": [[9, "f/_/rb_peek"]], "rb_read() (fortran subroutine)": [[9, "f/_/rb_read"]], "rb_read_options (fortran type)": [[9, "f/_/rb_read_options"]], "rb_write() (fortran subroutine)": [[9, "f/_/rb_write"]], "rb_write_options (fortran type)": [[9, "f/_/rb_write_options"]], "auction_inform (fortran type)": [[10, "f/spral_scaling/auction_inform"]], "auction_options (fortran type)": [[10, "f/spral_scaling/auction_options"]], "auction_scale_sym() (fortran subroutine)": [[10, "f/spral_scaling/auction_scale_sym"]], "auction_scale_unsym() (fortran subroutine)": [[10, "f/spral_scaling/auction_scale_unsym"]], "equilib_inform (fortran type)": [[10, "f/spral_scaling/equilib_inform"]], "equilib_options (fortran type)": [[10, "f/spral_scaling/equilib_options"]], "equilib_scale_sym() (fortran subroutine)": [[10, "f/spral_scaling/equilib_scale_sym"]], "equilib_scale_unsym() (fortran subroutine)": [[10, "f/spral_scaling/equilib_scale_unsym"]], "hungarian_inform (fortran type)": [[10, "f/spral_scaling/hungarian_inform"]], "hungarian_options (fortran type)": [[10, "f/spral_scaling/hungarian_options"]], "hungarian_scale_sym() (fortran subroutine)": [[10, "f/spral_scaling/hungarian_scale_sym"]], "hungarian_scale_unsym() (fortran subroutine)": [[10, "f/spral_scaling/hungarian_scale_unsym"]], "spral_scaling (module)": [[10, "f/spral_scaling"]], "spral_ssids (fortran program)": [[11, "f/spral_ssids"]], "spral_ssids (module)": [[11, "f/spral_ssids"]], "ssids_alter() (fortran subroutine)": [[11, "f/spral_ssids/ssids_alter"]], "ssids_analyse() (fortran subroutine)": [[11, "f/spral_ssids/ssids_analyse"]], "ssids_analyse_coord() (fortran subroutine)": [[11, "f/spral_ssids/ssids_analyse_coord"]], "ssids_enquire_indef() (fortran subroutine)": [[11, "f/spral_ssids/ssids_enquire_indef"]], "ssids_enquire_posdef() (fortran subroutine)": [[11, "f/spral_ssids/ssids_enquire_posdef"]], "ssids_factor() (fortran subroutine)": [[11, "f/spral_ssids/ssids_factor"]], "ssids_free() (fortran subroutine)": [[11, "f/spral_ssids/ssids_free"]], "ssids_inform (fortran type)": [[11, "f/spral_ssids/ssids_inform"]], "ssids_options (fortran type)": [[11, "f/spral_ssids/ssids_options"]], "ssids_solve() (fortran subroutine)": [[11, "f/spral_ssids/ssids_solve"]], "spral_ssmfe (module)": [[12, "f/spral_ssmfe"]], "ssmfe_buckling() (fortran subroutine)": [[12, "f/spral_ssmfe/ssmfe_buckling"], [14, "f/spral_ssmfe_expert/ssmfe_buckling"]], "ssmfe_free() (fortran subroutine)": [[12, "f/spral_ssmfe/ssmfe_free"], [13, "f/spral_ssmfe_core/ssmfe_free"], [14, "f/spral_ssmfe_expert/ssmfe_free"]], "ssmfe_generalized() (fortran subroutine)": [[12, "f/spral_ssmfe/ssmfe_generalized"], [14, "f/spral_ssmfe_expert/ssmfe_generalized"]], "ssmfe_generalized_shift() (fortran subroutine)": [[12, "f/spral_ssmfe/ssmfe_generalized_shift"], [14, "f/spral_ssmfe_expert/ssmfe_generalized_shift"]], "ssmfe_inform (fortran type)": [[12, "f/spral_ssmfe/ssmfe_inform"], [14, "f/spral_ssmfe_expert/ssmfe_inform"]], "ssmfe_options (fortran type)": [[12, "f/spral_ssmfe/ssmfe_options"], [14, "f/spral_ssmfe_expert/ssmfe_options"]], "ssmfe_rcid (fortran type)": [[12, "f/spral_ssmfe/ssmfe_rcid"], [14, "f/spral_ssmfe_expert/ssmfe_rcid"]], "ssmfe_rciz (fortran type)": [[12, "f/spral_ssmfe/ssmfe_rciz"], [14, "f/spral_ssmfe_expert/ssmfe_rciz"]], "ssmfe_standard() (fortran subroutine)": [[12, "f/spral_ssmfe/ssmfe_standard"], [14, "f/spral_ssmfe_expert/ssmfe_standard"]], "ssmfe_standard_shift() (fortran subroutine)": [[12, "f/spral_ssmfe/ssmfe_standard_shift"], [14, "f/spral_ssmfe_expert/ssmfe_standard_shift"]], "spral_ssmfe_core (module)": [[13, "f/spral_ssmfe_core"]], "ssmfe() (fortran subroutine)": [[13, "f/spral_ssmfe_core/ssmfe"]], "ssmfe_core_options (fortran type)": [[13, "f/spral_ssmfe_core/ssmfe_core_options"]], "ssmfe_infrom (fortran type)": [[13, "f/spral_ssmfe_core/ssmfe_infrom"]], "ssmfe_largest() (fortran subroutine)": [[13, "f/spral_ssmfe_core/ssmfe_largest"]], "spral_ssmfe_expert (module)": [[14, "f/spral_ssmfe_expert"]]}})